
/* String Util*/
void trim(const char *text, char *output, int max_len)
{
    int i, j, length;
    length = strlen(text);

    for(i=0; i<length; i++)
	{
        if ( (text[i] != ' ') && (text[i] != '\t') && (text[i] != '\n') && (text[i] != '\r')) {
            break;
        }
    }

    if (i == length) {
        output[0] = 0;
        return;
    }

    for (j=length-1; j>=0; j--) {
        if ( (text[j] != ' ') && (text[j] != '\t') && (text[j] != '\n') && (text[j] != '\r')) {
            break;
        }
    }

    length = j + 1 - i;
    strncpy(output, text + i, length);
    output[length] = 0;
}

int hex2long(char *s, char **n)
{
    int result=0;
    int digit;

    while(*s==' ' || *s=='\t') s++;

    while(true)
    {
        if(*s>='0' && *s<='9')
            digit=*s-'0';
        else if(*s>='a' && *s<='f')
            digit=*s-'a' + 10;
        else if (*s>='A' && *s<='F')
            digit=*s-'A' + 10;
        else break;
        result=(result<<4) | digit;
        s++;
    }
    if(n != NULL) *n=s;
    
    return result;
}

void string_to_format(char *input, size_t size)
{
    char buffer[2048], temp[5], *output=input;
    int i=0, j;

	while(*output!='\0')
	{
		if(*output=='\n')
		{
			buffer[i++]='^';
			buffer[i++]='n';
		}
		else if (*output=='\t')
		{
			buffer[i++]='^';
			buffer[i++]='t';
		}
		else if (*output=='"')
		{
			buffer[i++]='^';
			buffer[i++]='"';
		}
		else if (*output=='^')
		{
			buffer[i++]='^';
			buffer[i++]='^';
		}
		else if (*output > 0 && *output < 32)
		{
			buffer[i++]='^';
			buffer[i++]='x';
			formatex(temp, charmax(temp), "%02x", (int)*output);
			j=0;
			while(temp[j]!='\0')
			{
				buffer[i++]=temp[j++];
			}
		}
		else buffer[i++]=*output;
		++output;
	}
	buffer[i++]=0;

    strncpy(input, buffer, size);
}

void string_to_raw(char *input, size_t size)
{
    char buffer[2048], temp[3], *output=input;
	bool ctrlchar=false;
	int i=0;

	while(*output!='\0')
	{
		if(*output=='^')
		{
            if(!ctrlchar)
                ctrlchar = true;
            else {
		        buffer[i++]='^';
			    ctrlchar = false;
            }
		}
		else if(ctrlchar)
		{
            ctrlchar = false;
		    if(*output=='t')
                buffer[i++]='\t';
            else if(*output=='n')
                buffer[i++]='\n';
		    else if(*output=='"')
                buffer[i++]='"';
            else if(*output=='x')
            {
                temp[0] = *(++output);
                temp[1] = *(++output);
                temp[2] = 0;

                buffer[i++] = hex2long(temp, NULL);
            }
            else buffer[i++]=*output;
        }
        else buffer[i++]=*output;

        ++output;
    }
    buffer[i++]=0;

    strncpy(input, buffer, size);
}
